#
#  Analysis.py
#  EPR Power Saturation Analysis
#
#  Created by Grischa Meyer on 20.10.05.
#  Copyright (c) 2007 Grischa Meyer. All rights reserved.
#

from epr_tools import *
from r_interface import *

class Analysis:
    
    def __init__(self, fileBasename, powers, aStart, hStart, pStart):
        self.fileBasename = fileBasename
        self.powers = powers
        self.dists = maxMinDist( getPowerSpecData( self.fileBasename + ".spc", self.fileBasename + ".par" ))
        self.fit = fit( self.powers, self.dists, aStart, hStart, pStart )
    
    def plot( self, title = "Power (mW)" ):
        plotfit( self.powers, self.dists, self.fit, title )
    
    def plotdata( self ):
        plotdata( self.powers, self.dists )
    
    def result( self ):
        return self.fit['p']
