#
#  r_interface.py
#  EPR Power Saturation Analysis
#
#  Created by Grischa Meyer on 12.10.05.
#  Copyright (c) 2007 Grischa Meyer. All rights reserved.
#


# requires R to python interface from http://rpy.sourceforge.net/ and
# the R package from http://www.r-project.org/
# both available via fink on Macs
from rpy import *


function = "(a * x)/((1+((2^(1/h)-1)*x*x)/p)^h)"

# alternative outputs available, eg. "quartz()" or "PDF()", but X11 proved
# to be most reliable
def initRGraphics( output = "x11()" ):
    r(output)

def closeRGraphics():
    r("graphics.off()")

def fn( a, h, p, x):
	return eval(function)

def fit( x, y, astart = 100000, hstart = 1.0, pstart = 10 ):
	formula = "y ~ " + function
	r.assign( "x", x )
	r.assign( "y", y )
	r( "plot( x, y )" )
	return r("coef(nls( " + \
formula + ", start = list( a = " + \
`astart` + ", h = "+`hstart`+", p = "+`pstart`+" ) ))")

def plotdata ( x, y ):
	r.assign( "x", x )
	r.assign( "y", y )
	r( "plot( x, y )" )

def plotfit ( x, y, fit, xtitle ):
	r.assign( "x", x )
	r.assign( "y", y )
	r( "plot( x, y )" )
	r("fn <- function( a, h, p, x ) " + function )
	r.lines( r.spline( x, r.fn( fit['a'], fit['h'], fit['p'], x) ) )
